[![Build Status](https://travis-ci.org/sproutcore/sproutcore.png?branch=master)](https://travis-ci.org/sproutcore/sproutcore)

SproutCore: For Native-Caliber Web Apps
=======

SproutCore is a JS-MVC framework for building blazing-fast, native-caliber web
applications. SproutCore's full-stack approach to single-page application
development gives you the tools you need to build rich, powerful applications...
which happen to run in the browser.

## Getting Started

The easiest way to get started with SproutCore is to install the Ruby gem.
You can find instructions [here](http://sproutcore.com/install/). Once you've
got SproutCore installed, checkout the
[Getting Started](http://guides.sproutcore.com/getting_started.html) tutorial.

## Next Steps

Once you're through the Getting Started tutorial:

- Check out the [Showcase](http://showcase.sproutcore.com/) for demos of a number
  of views and concepts.
- Check out lead developer Tyler Keating's book,
  [SproutCore Web Application Development](http://blog.sproutcore.com/sproutcore-book-available/).
- Check out Juniper, the [web app](http://juniper.dcporter.net/) +
  [annotated source code](https://github.com/dcporter/juniper) combo, for a deep
  dive into SproutCore features and best practices in action.

## Support

Resources for SproutCore developers include [the docs](http://docs.sproutcore.com/)
for API documentation, and [the Guides](http://guides.sproutcore.com/) for a
series of topical walk-throughs.

For additional SproutCore user support, join the
[mailing list](https://groups.google.com/group/sproutcore), or stop by the #sproutcore
[IRC channel](http://sproutcore.com/community/#tab=irc). For those interested in
contributing to the framework itself, please join sproutcore-dev@googlegroups.com.

## Acknowledgements

SproutCore includes code from a number of different open source projects
including:

* [jQuery](http://www.jquery.com/)
* [Prototype](http://www.prototypejs.org/)
* [Datejs](http://www.datejs.com/)
* [JSON2](http://www.json.org/)

